import { clearRoom } from "./_clearRoom";
import { enter } from "./_enter";
import { loadoutChanged } from "./_loadoutChanged";
import { message } from "./_message";
import { playerJoin } from "./_playerJoin";
import { playerUpdate } from "./_playerUpdate";

export function registerLobbyCallbacks(socket){
    socket.on('lobby/enter', (data) => {
        enter(socket, data)
    });

    socket.on('lobby/cleared', (data) => {
        clearRoom(socket, data)
    });

    socket.on('lobby/playerJoin', (data) => {
        playerJoin(socket, data)
    });

    socket.on('lobby/playerUpdate', (data) => {
        playerUpdate(socket, data)
    });

    socket.on('lobby/loadoutChanged', (data) => {
        loadoutChanged(socket, data)
    });

    socket.on('lobby/message', (data) => {
        message(socket, data)
    });
}